<template>
  <v-btn
    :icon="currentState.icon"
    :color="currentState.severity"
    variant="tonal"
    size="small"
    @click="isConfirmShown = true"
  />

  <ConfirmationDialog
    v-model="isConfirmShown"
    :severity="currentState.severity as any"
    :is-loading="isLoading"
    :confirm-btn-icon="currentState.icon"
    :confirm-btn-label="currentState.confirmationLabel"
    @confirm="onConfirmClick"
  >
    {{ currentState.confirmationText }}
  </ConfirmationDialog>
</template>

<script setup lang="ts">
import { ref, computed } from 'vue';

import { useRatesStore } from '@/stores';
import { isArchived } from '@/utils';

import ConfirmationDialog from '@/components/layout/ConfirmationDialog.vue';

const props = defineProps<{ data: IRate }>();
const ratesStore = useRatesStore();

const isLoading = ref(false);
const isConfirmShown = ref(false);

const isRateArchived = computed(() => isArchived(props.data));

const currentState = computed(() => {
  if (isRateArchived.value) {
    return {
      icon: 'mdi-archive-arrow-up-outline',
      severity: 'success',
      confirmationLabel: 'Восстановить',
      confirmationText: (
        'Вы действительно хотите восстановить этот тариф?'
      ),
    };
  }

  return {
    icon: 'mdi-archive-arrow-down-outline',
    severity: 'error',
    confirmationLabel: 'В архив',
    confirmationText: (
      'Вы действительно хотите отправить этот тариф в архив?'
    ),
  };
});

const onConfirmClick = async () => {
  isLoading.value = true;

  const targetAction = isRateArchived.value
    ? 'restoreRate'
    : 'archiveRate';

  await ratesStore[targetAction](props.data.id);

  isLoading.value = false;
  isConfirmShown.value = false;
};
</script>